program Mehrzweck_Interface;
uses CRT;
const BA = $3F8;                           { COM 1 }
var Dout, Din, Ain : Byte;

procedure Austausch;
var Stelle, StelleAD, n, m  : Integer;
begin
  Port [BA+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;                       { Verzgerung }
  Port [BA+4] := 0;                        { Strobe aus (RTS) }
  Stelle := 1;
  StelleAD := 128;
  Din := 0;
  Ain := 0;
  for n:=1 to 8 do begin
    if ((Dout AND Stelle) > 0) then
      Port [BA+3] := 64                    { Daten ausgeben (TXD) }
      else Port [BA+3] := 0;
    if (Port[BA+6] AND 128) = 128          { Daten lesen (DCD) }
       then Din := Din + Stelle;
    if (Port[BA+6] AND 32) = 32 then       { A/D lesen (DSR) }
       Ain := Ain + StelleAD;
    Port [Ba+4] := 1;                      { Clock an (DTR) }
    Stelle := Stelle * 2;
    StelleAD := StelleAD div 2;
    Port [BA+4] := 0;                      { Clock aus (DTR) }
  end;
  Port [BA+4] := 2;                        { Strobe an (RTS) }
  for m:=1 to 10 do;
  Port [BA+4] := 0;                        { Strobe aus (RTS) }
end;

begin
  Dout:=0;
  repeat
    Austausch;
    Dout:=Dout+1;
    delay (100);
    writeln (Din,'  ',Ain);
  until KeyPressed;
end.

begin
  Dout:=0;
  repeat
    Austausch;
    Dout:=Dout+1;
    delay (100);
    writeln (Din,'  ',Ain);
  until KeyPressed;
end.
