Program Spannungsmessung_4_Kanal;
Uses Crt;
const  BA = $3F8;                     { COM 1 }
var    Negativ, Positiv, Zeitfaktor : Real;

function Zaehler (Kanal:Byte): Integer;
var Eingang, n : Integer;
begin
 Eingang:=16;                         { CTS }
 If Kanal=2 then Eingang := 32;       { DSR }
 If Kanal=3 then Eingang := 64;       { RI }
 If Kanal=4 then Eingang := 128;      { DCD }
 N := 0;
 delay (100);
 Inline ($FA);                        { Interrupt sperren }
 Port [BA+4] := 3;                    { DTR=1, RTS=1 }
 repeat
   N := N +1;                         { zhlen }
 until ((Port[BA+6] and Eingang)=0);  { bis Eingang = 0 }
 Port[BA+4] := 2;                     { DTR=0; RTS=1 }
 Inline ($FB);                        { Interrupt freigeben }
 Zaehler := N;
end;

procedure Kalibrieren;
begin
  Zeitfaktor := -(Zaehler(1)/ln(1-Negativ/(Positiv+Negativ)));
end;

function Spannung (Kanal: Integer) : Real;
begin
  Spannung :=(Negativ+Positiv)*(1-exp(-Zaehler(Kanal)/Zeitfaktor))-Negativ;
end;

begin
 Negativ := 8.2;                      { Feinabgleich! }
 Positiv := 8.2;                      { Feinabgleich! }
 Kalibrieren;
 ClrScr;
 repeat
  GotoXY (10,10);
  write (Spannung (1) :3:2, ' V          ');
  writeln (Spannung (2) :3:2, ' V          ');
 until KeyPressed;
end.
