Program Joystick_Spannung;
uses CRT;
var Nullwert: Word;
    Ch : Char;

function Zaehler (Kanal : Integer) : Word;
var n : word;
    Portwert : Byte;
begin
  Portwert := 1;                      { A0 }
  if Kanal=2 then Portwert := 2;      { A1 }
  if Kanal=3 then Portwert := 4;      { A2 }
  if Kanal=4 then Portwert := 8;      { A3 }
  n:=0;
  Inline ($FA);                       { Interrupt sperren }
  port[$201]:= 0;                     { Timer-Reset }
  repeat
    n:=n+1;                           { zhlen bis Bit=0 }
  until ((Port [$201] and Portwert) = 0) or (n>10000);
  Inline ($FB);                       { Interrupt freigeben }
  Zaehler := n;
end;

function Uin: Real ;
begin
  Uin := 3.33 * (1/(1-exp(-Zaehler(4)/Nullwert))-1/(1-exp(-1)));
end;

procedure Kalibrieren;
begin
  Nullwert := Zaehler (4);            { Messung an A3 }
end;

begin
  Nullwert := 340;
  ClrScr;
  repeat
    repeat
      GotoXY (1,10);
      writeln ('Spannung gegen +5V   = ',Uin :3:1,' V   ');
      writeln ('Spannung gegen Masse = ',Uin+5 :3:1, ' V   ');
      delay (200);
    until KeyPressed;
    Ch := upcase (ReadKey);
    If Ch = 'K' then Kalibrieren;
  until Ch = chr(27);
end.
