Program PCF8574_Logik_Analysator;
Uses CRT, Graph, I2C_LPT1;
var m, n: Word;
    Puffer : Array [1..5000] of Byte;

procedure ParallelAus (Wert: Byte);
begin
  Start;
  Ausgeben (32 * 2);        { Adresse 32, schreiben }
  Ausgeben (Wert);          
  Stop;                     
end;                        

function ParallelEin : Byte;
begin                       
  Start;                    
  Ausgeben (32 * 2 + 1);    { Adresse 32, lesen }
  ParallelEin := Einlesen;
  KeinAcknowledge;
  Stop;
end;

procedure Serie;
var Dummy : Byte;
begin
  ParallelAus (255);
  Start;
  Ausgeben (32 * 2 + 1);       { Adresse 32, lesen }
  for n := 1 to 700 do begin;
     Puffer [n] := Einlesen;   { 700 mal Daten lesen }
     Acknowledge;              { Empfang besttigen }
     delay (10);
  end;
  Dummy := Einlesen;           { einmal einlesen }
  KeinAcknowledge;             { nicht besttigen }
  Stop;                        { abmelden }
end;

procedure GrafikAusgabe;
var Graphdriver, Graphmode, Graphcode : Integer;
    Wert : Byte;
begin
  graphDriver := Detect;
  InitGraph (Graphdriver, Graphmode, '');
  SetLineStyle (1,2,1);
  for n:= 1 to 8 do begin
    Line (0,n*20,700,n*20);
  end;
  SetLineStyle (0,2,1);
  Wert := 1;
  for n := 1 to 8 do begin
    for m := 2 to 700 do begin
      Line (m-1,n*20-12*((Puffer[m-1] and Wert) div Wert),
         m,n*20-12*((Puffer[m] and Wert) div Wert));
    end;
    Wert := Wert * 2;
  end;
  repeat until KeyPressed;
  CloseGraph;
end;

begin
  ClrScr;
  Serie;
  GrafikAusgabe;
end.
